﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using Infragistics.Web.UI.GridControls;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        Session["childDS"] = childDS();
        WebHierarchicalDataGrid1.DataSource = populateGrid();
        WebHierarchicalDataGrid1.DataBind();
    }


    protected DataSet populateGrid()
    {
        DataTable dt = new DataTable();
        dt.Columns.Add("Name");
        DataRow row;
        for (int i = 0; i < 50; i++)
        {
            row = dt.NewRow();
            row.SetField<string>("Name", "Name" + i);
            dt.Rows.Add(row);
        }

        dt.PrimaryKey = new DataColumn[] { dt.Columns[0] };

        DataTable dt1 = new DataTable();
        dt1.Columns.Add("Name");
        
        for (int i = 0; i < 50; i++)
        {
            row = dt1.NewRow();
            row.SetField<string>("Name", "Name" + i);
            dt1.Rows.Add(row);
        }

        dt1.PrimaryKey = new DataColumn[] { dt1.Columns[0] };

        DataSet ds = new DataSet();
        ds.Tables.Add(dt);
        ds.Tables.Add(dt1);

        ds.Relations.Add(dt.Columns[0], dt1.Columns[0]);

        return ds;
    }


    protected DataTable childDS()
    {
        DataTable dt = new DataTable();
        dt.TableName = "child";
        dt.Columns.Add("Name");
        DataRow row;
        for (int i = 0; i < 10; i++)
        {
            row = dt.NewRow();
            row.SetField<string>("Name", "Name" + i);
            dt.Rows.Add(row);
        }

        return dt;
    }

    protected void WebHierarchicalDataGrid1_RowIslandsPopulating(object sender, Infragistics.Web.UI.GridControls.ContainerRowCancelEventArgs e)
    {
        e.Cancel = true;
        ContainerGrid grid = new ContainerGrid();

        e.Row.RowIslands.Add(grid);

        grid.DataSource = childDS();


    }
    protected void WebHierarchicalDataGrid1_RowIslandDataBinding(object sender, RowIslandEventArgs e)
    {
        //for manual lod null will be returned for the band here. In this simple scenario all children are bound to the same ds.
        //Parent row may be accessed to customize this.
        if (e.RowIsland.Band == null)
        {
           e.RowIsland.DataSource = childDS();
        }

    }
}